//*****************************************************************************
//*
//*
//*		Mailslots.h
//*
//*
//*****************************************************************************
#ifndef		__MAILSLOTS_H__
#define 	__MAILSLOTS_H__

#ifdef		GLOBAL_CONFIG
#define 	MAILSLOTS_H
#include	<GlobalConfig.h>
#undef		MAILSLOTS_H
#endif

#ifdef		_MSC_VER
#pragma 	warning( disable :4996 )
#endif

#ifdef		__cplusplus
extern		"C" {
#define 	D(a)	a
#else
#define 	D(a)
#endif




	typedef unsigned Mailslot;


	Mailslot	MailslotCreate (int iItemSize,int iQueueSize);
	void		MailslotDelete (Mailslot hMailslot);
	int			MailslotGetWait(Mailslot hMailslot,      void *pData,               unsigned uTimeout);
	int			MailslotPutWait(Mailslot hMailslot,const void *pData,unsigned uSize,unsigned uTimeout);
	int			MailslotPeek   (Mailslot hMailslot,      void *pData,unsigned uPosition              );
	int			MailslotClear  (Mailslot hMailslot,int iCount);
	int			MailslotCount  (Mailslot hMailslot);
	int			MailslotInfo   (Mailslot hMailslot,int *pItemSize D(=0),int *pSlotCount D(=0));

	#define 	MailslotGet(h,p)	MailslotGetWait(h,p,0)
	#define 	MailslotPut(h,p,s)	MailslotPutWait(h,p,s,0)





#ifdef	__cplusplus
}
#endif

#undef	D

#endif
